import java.io.*;

public class BatchBookGen { 
    public static String VENDOR = "knizhnik@garret.ru";


    public static void main(String[] args) throws Exception { 
        if (args.length < 1) { 
            System.err.println("Usage: java BatchBookGen directory {directory}");
        }
        for (int i = 0; i < args.length; i++) { 
            File dir = new File(args[i]);
            traverse(dir, "");
        }
    }


    static void traverse(File dir, String back) throws Exception { 
        PrintStream ps;
        String[] files = dir.list();
        for (int i = 0; i < files.length; i++) { 
            String fileName = files[i];
            File f = new File(dir, fileName);
            if (f.isDirectory()) { 
                traverse(f, back + "../");
            }
            if (back.length() == 0 || fileName.startsWith("_") || (!fileName.endsWith(".htm") && !fileName.endsWith(".html")) || fileName.startsWith("index")) { 
                continue;
            }
            File original = new File(dir, '_' + fileName);
            if (original.exists()) { 
                //continue;
            } else { 
                f.renameTo(original);
            }
            String name = fileName.substring(0, fileName.lastIndexOf('.'));
            ps = new PrintStream(new FileOutputStream("MANIFEST.MF"));
            ps.println("MIDlet-1: " + name + ", /book.png, BookReader");
            ps.println("MIDlet-Name: " + name);
            ps.println("MIDlet-Vendor: " + VENDOR);
            ps.println("MIDlet-Version: 1.0");
            ps.println("MicroEdition-Configuration: CLDC-1.0");
            ps.println("MicroEdition-Profile: MIDP-1.0");
            ps.close();

            InputStream in = new FileInputStream(original);
            byte[] buf = new byte[(int)original.length()];
            int len = in.read(buf);
            if (len != buf.length) { 
                throw new Error("Failed to read file");
            }
            if (len == 0) { 
                continue;
            }
            int src = 0, dst = 0;
            boolean html = buf[0] == '<';             
            while (src < len) { 
                byte b = buf[src++];
                if (html && b == '<') { 
                    if (src+2 < len && buf[src] == '!' && buf[src+1] == '-' && buf[src+2] == '-') {
                        src += 2;
                        do { 
                            src += 1;
                        } while (src+3 < len && !(buf[src] == '-' &&  buf[src+1] == '-' &&  buf[src+2] == '>'));
                        src += 3;
                    } else if (src+1 < len && (buf[src] == 'p' || buf[src] == 'P') && (buf[src+1] == ' ' || buf[src+1] == '>')) { 
                        buf[dst++] = '\n';
                        while (src < len && buf[src++] != '>');
                    } else { 
                        int start = src;
                        do { 
                            if (src == len) { 
                                src = start;
                                break;
                            }
                        } while (buf[src++] != '>');
                    }
                } else if (html && b == '&') { 
                    if (src+3 < len && buf[src] == 'q' && buf[src+1] == 'u' && buf[src+2] == 'o' && buf[src+3] == 't') { 
                        buf[dst++] = '"';
                        src += 5;
                    } else if (src+3 < len && buf[src] == 'n' && buf[src+1] == 'b' && buf[src+2] == 's' && buf[src+3] == 'p') { 
                        buf[dst++] = '"';
                        src += 5;
                    } else if (src+2 < len && buf[src] == 'a' && buf[src+1] == 'm' && buf[src+2] == 'p') { 
                        buf[dst++] = '&';
                        src += 4;
                    } else if (src+1 < len && buf[src] == 'l' && buf[src+1] == 't') { 
                        buf[dst++] = '<';
                        src += 3;
                    } else if (src+1 < len && buf[src] == 'g' && buf[src+1] == 't') { 
                        buf[dst++] = '>';
                        src += 3;
                    } else if (src+2 < len && buf[src] == '#') {                        
                        if (Character.isSpace((char)buf[++src])) { 
                            src += 1;
                        }
                        if (buf[src] == 'x') {                             
                            int start = ++src;
                            while (++src < len && Character.isLetterOrDigit((char)buf[src]));
                            buf[dst++] = (byte)Integer.parseInt(new String(buf, start, src-start).trim(), 16);
                        } else { 
                            int start = src;
                            while (++src < len && Character.isDigit((char)buf[src]));
                            buf[dst++] = (byte)Integer.parseInt(new String(buf, start, src-start).trim());
                        }  
                        if (src < len && buf[src] == ';') { 
                            src += 1;
                        }
                    } else { 
                        buf[dst++] = b;
                    }
                } else if (b != '\r' && b >= (byte)0xC0) { 
                    buf[dst++] = b;
                }
            }
            OutputStream out = new FileOutputStream("res/book.txt");
            out.write(buf, 0, dst);
            out.close();
            
            DataOutputStream cfg = new DataOutputStream(new FileOutputStream("res/config"));
            cfg.writeInt(dst);
            cfg.close();
            
            Runtime rt = Runtime.getRuntime();
            String path = dir.getPath() + '/' + name;
            Process proc = rt.exec("jar cfm " + path + ".jar MANIFEST.MF -C classes . -C res .");
            proc.waitFor();
        
            File jar = new File(path + ".jar");
            
            ps = new PrintStream(new FileOutputStream(path + ".jad"));
            ps.println("MIDlet-1: " + name + ", /book.png, BookReader");
            ps.println("MIDlet-Jar-Size: " + jar.length());
            ps.println("MIDlet-Jar-URL: " + name + ".jar");
            ps.println("MIDlet-Name: " + name);
            ps.println("MIDlet-Vendor: " + VENDOR);
            ps.println("MIDlet-Version: 1.0");
            ps.println("MicroEdition-Configuration: CLDC-1.0");
            ps.println("MicroEdition-Profile: MIDP-1.0");
            ps.close();
            /* 
               String path = dir.getPath() + '/' + name;
               File jar = new File(path + ".jar");
            */
            ps = new PrintStream(new FileOutputStream(new File(dir, fileName)));
            ps.println("<html><head><meta http-equiv=\"Content-Type\" content=\"text/html;charset=windows-1251\">");
            ps.println("</head><link rel=\"stylesheet\" href=\"" + back + "style.css\"><body><ul>");
            ps.println("<li><a href=\"_" + fileName + "\">" + fileName + "</a>");
            ps.println("<li><a href=\"" + name + ".jad\">" + name + ".jad</a>");
            ps.println("<li><a href=\"" + name + ".jar\">" + name + ".jar (" + jar.length()/1024 + "kb)</a>");
            ps.println("</ul></body></html>");
            ps.close();

            System.out.println("Generate book " + path);
        }
    }
}