import javax.microedition.lcdui.*;
import java.util.Vector;

public class BookmarkList extends List implements CommandListener { 
    ReaderCanvas canvas;
    Displayable  parent;
    
    BookmarkList(ReaderCanvas canvas, Displayable parent) { 
        super(Locale.BOOKMARKS, IMPLICIT);
        this.canvas = canvas;
        this.parent = parent;
        addCommand(BookReader.ADD_CMD);
        addCommand(BookReader.RENAME_CMD);
        addCommand(BookReader.REMOVE_CMD);
        addCommand(BookReader.GOTO_CMD);
        addCommand(BookReader.BACK_CMD);
        Vector bookmarks = canvas.reader.bookmarks;
        for (int i = 0, n = bookmarks.size(); i < n; i++) { 
            append(((Bookmark)bookmarks.elementAt(i)).name, null);
        }
        setCommandListener(this);
        Display.getDisplay(canvas.reader).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        int i = getSelectedIndex();
        if (c == BookReader.BACK_CMD) { 
            Display.getDisplay(canvas.reader).setCurrent(parent);
        } else if (c == BookReader.ADD_CMD) { 
            new AddBookmarkForm(canvas, this);
        } else if (c == BookReader.RENAME_CMD) { 
            new EditBookmarkForm(canvas, this, i);
        } else if (c == BookReader.REMOVE_CMD) { 
            canvas.reader.removeBookmark(i);
            delete(i);
        } else { 
            canvas.setPosition(((Bookmark)canvas.reader.bookmarks.elementAt(i)).pos);
            Display.getDisplay(canvas.reader).setCurrent(canvas);
        }
    }
}


