import javax.microedition.lcdui.*;

public class Menu extends List implements CommandListener { 
    ReaderCanvas canvas;
    
    static String[] items = {Locale.BOOKMARKS, Locale.SEARCH, Locale.SETTINGS, Locale.HELP, Locale.CLOCK, Locale.QUIT};

    Menu(ReaderCanvas canvas) { 
        super(Locale.MENU, IMPLICIT, items, null);
        this.canvas = canvas;
        addCommand(BookReader.BACK_CMD);
        setCommandListener(this);
        Display.getDisplay(canvas.reader).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == BookReader.BACK_CMD) { 
            Display.getDisplay(canvas.reader).setCurrent(canvas);
        } else { 
            switch (getSelectedIndex()) { 
            case 0: 
                new BookmarkList(canvas, this);
                break;
            case 1:
                new SearchForm(canvas, this);
                break;
            case 2:
                new SettingsForm(canvas, this);
                break;
            case 3:
                new HelpForm(canvas, this);
                break;
            case 4:
            { 
                Alert a = new Alert(Locale.CLOCK, canvas.reader.getTime(), null, AlertType.INFO);
                Display.getDisplay(canvas.reader).setCurrent(a, canvas);
                break;
            }
            case 5:
                canvas.reader.quit();
                break;
            }
        }
    }
}


